CON

    Baro_Addr = $EE  'i2c address of baro sensor

OBJ
   i2c      : "I2CDriver"

VAR
   byte Baro_Data_f6
   byte Baro_Data_f7
   byte Baro_Data_f8
   byte Baro_Data_f9
   byte Baro_Data_fa
   byte Baro_Data_fb
   byte Baro_Data_fc
   byte Baro_Data_fd
   byte Baro_Data_fe
   byte Baro_Data_ff
  
   long _220uS
   long _40uS
   
   byte i2cSCL, i2cSDA
   
PUB init(_scl, _sda)
   i2cSCL := _scl
   i2cSDA := _sda
   i2c.i2cStart (i2cSCL)
   _220uS := clkfreq / 100_000 * 22 
   _40uS := clkfreq / 100_000 * 4 

PUB start_adcTemp
   i2c.i2cStart (i2cSCL)
   i2c.i2cWrite(i2cSCL,Baro_Addr)         'write 0xEE to i2c bus
   i2c.i2cWrite(i2cSCL,$F4)               'write 0xF4 to i2c bus
   i2c.i2cWrite(i2cSCL,$EE)               'write 0xEE sequence to start temp conversion   
   i2c.i2cStop (i2cSCL)

PUB start_adcPres
   i2c.i2cStart (i2cSCL)
   i2c.i2cWrite(i2cSCL,Baro_Addr)         'write 0xEE to i2c bus
   i2c.i2cWrite(i2cSCL,$F4)               'write 0xF4 to i2c bus
   i2c.i2cWrite(i2cSCL,$F4 )              'write 0xF4 sequence to start pressure conversion   
   i2c.i2cStop (i2cSCL)
  
PUB readbaro
   
   i2c.i2cStart (i2cSCL)
   i2c.i2cWrite(i2cscl,Baro_Addr)         'write 0xEE to i2c bus sensor write address
   i2c.i2cWrite(i2cscl,$F6)               'write 0xF6 to i2c bus sensor starting register
   i2c.i2cStart (i2cSCL)                    'do a restart
   i2c.i2cWrite(i2cscl,Baro_Addr|1)       'write 0xEF (read cmd) to i2c bus sensor read address   

   Baro_Data_f6 := (i2c.i2cRead(i2cscl,0))         'i2c read 12 BYTES with ack bit
   Baro_Data_f7 := (i2c.i2cRead(i2cscl,0))         '           V
   Baro_Data_f8 := (i2c.i2cRead(i2cscl,0))         '           V
   Baro_Data_f9 := (i2c.i2cRead(i2cscl,0))         '           V
   Baro_Data_fa := (i2c.i2cRead(i2cscl,0))         '           V
   Baro_Data_fb := (i2c.i2cRead(i2cscl,0))         '           V
   Baro_Data_fc := (i2c.i2cRead(i2cscl,0))         '           V
   Baro_Data_fd := (i2c.i2cRead(i2cscl,0))         '           V
   Baro_Data_fe := (i2c.i2cRead(i2cscl,0))         '           V
   Baro_Data_ff := (i2c.i2cRead(i2cscl,1))         '           V
    i2c.i2cStop (i2cSCL)
   

PUB Baro_f6
   return Baro_Data_f6

PUB Baro_f7
   return Baro_Data_f7

PUB Baro_f8
   return Baro_Data_f8

PUB Baro_f9
   return Baro_Data_f9

PUB Baro_fa
   return Baro_Data_fa

PUB Baro_fb
   return Baro_Data_fb

PUB Baro_fc
   return Baro_Data_fc

PUB Baro_fd
   return Baro_Data_fd

PUB Baro_fe
   return Baro_Data_fe

PUB Baro_ff
   return Baro_Data_ff